import { Meta, Preview, Props, Story } from '@storybook/addon-docs/blocks';
import { DependenciesTable } from 'storybook-addon-deps/blocks';
import { withKnobs, object } from '@storybook/addon-knobs';

import AClusterUi from './AClusterUi.vue';
import ABadgeUi from '../../atoms/ABadge/ABadgeUi.vue';

<Meta
  title="Core/Molecules/AClusterUi"
  component={AClusterUi}
  parameters={{ component: AClusterUi }}
/>

# A-Cluster-Ui

This component exists for convenience. It's only a wrapper for [AClusterL](/?path=/docs/core-layouts-aclusterl--default-story)
to hide the intermediary `div` wrapper node that manages negative spacing.

<Preview>
  <Story name="default" decorators={[withKnobs]}>
    {{
      components: { AClusterUi, ABadgeUi },
      props: {
        styles: {
          default: () =>
            object(
              'CSS Variables',
              {
                '--a-cluster-ui--justify': 'flex-start',
                '--a-cluster-ui--align': 'center',
                '--a-cluster-ui--space': '0.5rem',
                '--a-cluster-ui--overflow-x': 'hidden',
                '--a-cluster-ui--overflow-y': 'hidden',
              },
              'Styles'
            ),
        },
      },
      template: `
        <a-box-l class="reset w-48 p-1 bg-gray-200">
          <a-cluster-ui :style="styles">
            <a-badge-ui>Foo</a-badge-ui>
            <a-badge-ui>Foo-Bar</a-badge-ui>
            <a-badge-ui>Bar</a-badge-ui>
            <a-badge-ui>Bar-Baz</a-badge-ui>
            <a-badge-ui>Baz</a-badge-ui>
          </a-cluster-ui>
        </a-box-l>
      `,
    }}
  </Story>
</Preview>

## API

<Props of={AClusterUi} />

## Installation

```bash
yarn add -E @bit/adakode.ak-ui.core.molecules.a-cluster
```

Install the component layout dependency:

```bash
yarn add -E @bit/adakode.ak-ui.core.layouts.a-cluster
```

## Usage

```html
<!-- Basic Cluster -->
<a-cluster-ui>
  <!-- child element here -->
  <!-- another child element -->
  <!-- etc -->
  <!-- etc -->
  <!-- etc -->
</a-cluster-ui>
```

## Customization

There are several ways to customize the look and feel of the component,
depending on the desired scope of the customization.

### Global Customization

To customize the look and feel of **every single instance** of the component
create a css file defining a class named after the kebab-case version of the component name
and define any of the custom properties below:

| CSS variable                 |      default | design token         |
| :--------------------------- | -----------: | :------------------- |
| `--a-cluster-ui--justify`    | `flex-start` | `n/a`                |
| `--a-cluster-ui--align`      |     `center` | `n/a`                |
| `--a-cluster-ui--space`      |     `0.5rem` | `theme('spacing.2')` |
| `--a-cluster-ui--overflow-x` |     `hidden` | `n/a`                |
| `--a-cluster-ui--overflow-y` |     `hidden` | `n/a`                |

These are the steps:

```bash
mkdir -p src/assets/styles/components/ui/core/molecules && touch $_/AClusterUi.css
```

```css
/* <rootDir>/src/assets/styles/components/index.css */
@import './ui/core/molecules/AClusterUi.css';
```

```css
/* <rootDir>/src/assets/styles/components/ui/core/molecules/AClusterUi.css */
.a-cluster-ui {
  --a-cluster-ui--justify: flex-start;
  --a-cluster-ui--align: center;
  --a-cluster-ui--space: theme('spacing.2');
  --a-cluster-ui--overflow-x: hidden;
  --a-cluster-ui--overflow-y: hidden;
}
```

### Scoped Customization

To customize the look and feel of a **group of instances** of the component
augment the specificity of the component class with a scoping data attribute:

```css
/* <rootDir>/src/assets/styles/components/ui/core/layouts/AClusterUi.css */
.a-cluster-ui[data-flow='rtl'] {
  --a-cluster-ui--justify: flex-end;
}
```

```html
<!-- <rootDir>/src/components/path/to/the/ConsumerComponent.vue -->
<!-- A right to left Cluster -->
<a-cluster-ui :data-flow="rtl">
  <!-- child element here -->
  <!-- another child element -->
  <!-- etc -->
  <!-- etc -->
  <!-- etc -->
</a-cluster-ui>
```

### Instance Customization

To customize the look and feel of a **single instance** of the component
you can define the desired CSS variables inline:

```html
<!-- Using CSS variables -->
<a-cluster-ui
  :style="{
    '--a-cluster-ui--justify': 'flex-start',
    '--a-cluster-ui--align': 'center',
    '--a-cluster-ui--space': '0.5rem',
    '--a-cluster-ui--overflow-x': 'hidden',
    '--a-cluster-ui--overflow-y': 'hidden',
  }"
>
  <!-- child element here -->
  <!-- another child element -->
  <!-- etc -->
  <!-- etc -->
  <!-- etc -->
</a-cluster-ui>
```

## Dependencies

<DependenciesTable
  titleDependencies="Dependencies"
  titleDependents="Dependents"
  of={AClusterUi}
/>

## Links

Source: https://gitlab.com/adakodecoop/coop/adakode-ui/-/tree/master/src/components/ui/core/molecules/ACluster  
Bit: https://bit.dev/adakode/ak-ui/core/molecules/a-cluster
